
export default class GithubLocations {

    constructor(user, repo) {
        this.user = user;
        this.repo = repo;
    }

    get mainUrl() {
        return `https://api.github.com/repos/${this.user}/${this.repo}/git/trees/main`
    }

    async extractLocations() {
        const locationTreeInfo = await this._extractLocationTreeData();
        const data = await fetch(locationTreeInfo.url);
        const json = await data.json();

        const locations = [];
        for (const treeInfo of json.tree) {
            locations.push({ name: treeInfo.path, url: treeInfo.url });
        }
        return locations;

    }

    async _extractLocationTreeData() {
        const data = await fetch(this.mainUrl);
        const json = await data.json();
        console.log(json)
        for (const treeInfo of json.tree) {
            if (treeInfo.path === 'locations') {
                return treeInfo;
            }
        }
    }

}



